<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright &#169; 2002 - 2006 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| Shoutbox v6.01.4.2r - Modded by Shedrock 2006
+----------------------------------------------------*/
require_once "../../maincore.php";
if (!isset($_POST)) { exit; }
header("Content-type: application/x-javascript; charset=UTF-8");

if (file_exists(INFUSIONS."shoutbox_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."shoutbox_panel/locale/".$settings['locale'].".php";
} else { include INFUSIONS."shoutbox_panel/locale/English.php"; }

require_once INFUSIONS."shoutbox_panel/parser.php";
require_once INFUSIONS."shoutbox_panel/functions.php";

/*******************************************************************
* Set minimum and maximum shouts you want displayed on each level
* and color of the boxover tips used for user info.
*******************************************************************/

$min = 5;	// minimum visible shouts in first level.
$max = 5;	// maximum number of shouts in second level (hidden).
$textcolor = "#244A60";	// sets miscellaneous text in the boxover tips.

/******************************************************************/

$fsb_page = "";
$basedir = stripinput($_POST['basedir']);
$basedirlen = strlen(BASEDIR);
$images = $basedir.substr(IMAGES, $basedirlen);
$infusions = $basedir.substr(INFUSIONS, $basedirlen);
$admin = $basedir.substr(ADMIN, $basedirlen);
$theme = $basedir.substr(THEME, $basedirlen);
$fusion_self = stripinput($_POST['fusion_self']);
$sb_action = isset($_POST['sb_action']) ? stripinput($_POST['sb_action']) : "";

if ($sb_action != "refresh") {
	if (iMEMBER) {
		$result = dbquery("UPDATE fusion_users SET user_lastvisit='".time()."', user_ip='".USER_IP."' WHERE user_id='".$userdata['user_id']."'");
	}
	$cond = ($userdata['user_level'] != 0 ? "'".$userdata['user_id']."'" : "'0' AND online_ip='".USER_IP."'");
	$result = dbquery("SELECT * FROM fusion_online WHERE online_user=".$cond."");
	if (dbrows($result) != 0) {
		$result = dbquery("UPDATE fusion_online SET online_lastactive='".time()."' WHERE online_user=".$cond."");
	} else {
		$name = ($userdata['user_level'] != 0 ? $userdata['user_id'] : "0");
		$result = dbquery("INSERT INTO fusion_online (online_user, online_ip, online_lastactive) VALUES ('$name', '".USER_IP."', '".time()."')");
	}
	$result = dbquery("DELETE FROM fusion_online WHERE online_lastactive<".(time()-60)."");
}

switch($sb_action) {

	case "shout":
		if (iMEMBER || $settings['guestposts'] == "1") {
			if (isset($_POST['post_shout'])) {
				$flood = false;
				$shout_user = ""; $shout_name = ""; $shout_message = "";
				
				if (isset($_POST['shout_id']) && isNum($_POST['shout_id']) && checkrights("S") && $aid == iAUTH) {
					$shout_id = $_POST['shout_id'];
					if (isset($_POST['user_id']) && isNum($_POST['user_id'])) { $shout_user = $_POST['user_id']; }
					$shout_name = mb_convert_encoding($_POST['shout_name'], $locale['charset'], "UTF-8");
					$shout_name = trim(stripinput($shout_name));
					$shout_name = preg_replace("(^[0-9]*)", "", $shout_name);
					if (isNum($shout_name)) { $shout_name = ""; }
				} else {
					if (iMEMBER) { $shout_name = $userdata['user_id']; }
					elseif ($settings['guestposts'] == "1") {
						$shout_name = trim(stripinput($_POST['shout_name']));
						$shout_name = preg_replace("(^[0-9]*)", "", $shout_name);
						if (isNum($shout_name)) { $shout_name = ""; }
					}
				}
				$shout_message = mb_convert_encoding($_POST['shout_message'], $locale['charset'], "UTF-8");
				$shout_message = str_replace("\n", " ", $shout_message);
				$shout_message = preg_replace("/^(.{400}).*$/", "$1", $shout_message);
				$shout_message = preg_replace("/([^\s]{25})/", "$1\n", $shout_message);
				$shout_message = trim(stripinput(censorwords($shout_message)));
				$shout_message = str_replace("\n", "<br>", $shout_message);

				// Added by Yuras. Scan for links in the shout. If there is, replace it with [URL]
		
				$i = 0; $ShoutNew = "";
				$ShoutArray = explode(" ",$shout_message);
				foreach($ShoutArray as $ShoutPart) {
					$ShoutPart = str_replace("<br>", "", $ShoutPart);
					if (eregi("http:\/\/", $ShoutPart)) {
						// fix for users adding text to the beginning of links: HACKhttp://www.website.com
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"http://");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'><b>Click Me!</b></a>&#93;";
					} elseif (eregi("ftp:\/\/", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"ftp://");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'>FTP</a>&#93;";
					} elseif (eregi("irc:\/\/", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"irc://");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>IRC</a>&#93;";
					} elseif (eregi("teamspeak:\/\/", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"teamspeak://");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>TeamSpeak</a>&#93;";
					} elseif (eregi("aim:goim", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"aim:goim");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>AIM</a>&#93;";
					} elseif (eregi("gopher:\/\/", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"gopher://");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>Gopher</a>&#93;";
					} elseif (eregi("mailto:", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"mailto:");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutNew[$i] = "&#91;<a href='$ShoutPart'>E-Mail</a>&#93;";
					} elseif (eregi("www\.", $ShoutPart)) {
						$ShoutPartL = strtolower($ShoutPart);
						$spot = strpos($ShoutPartL,"www.");
						if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
						$ShoutPart = "http://" . $ShoutPart;
						$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'>URL</a>&#93;";
					} elseif ((eregi("\.com", $ShoutPart)) OR (eregi("\.net", $ShoutPart)) OR (eregi("\.org", $ShoutPart)) OR (eregi("\.mil", $ShoutPart)) OR (eregi("\.gov", $ShoutPart)) OR (eregi("\.info", $ShoutPart)) OR (eregi("\.us", $ShoutPart)) OR (eregi("\.biz", $ShoutPart)) OR (eregi("\.tv", $ShoutPart)) OR (eregi("\.cc", $ShoutPart)) OR (eregi("\.ws", $ShoutPart)) OR (eregi("\.name", $ShoutPart)) OR (eregi("\.pro", $ShoutPart)) OR (eregi("\.co\.uk", $ShoutPart)) OR (eregi("\.ca", $ShoutPart)) OR (eregi("\.de", $ShoutPart)) OR (eregi("\.jp", $ShoutPart)) OR (eregi("\.ro", $ShoutPart)) OR (eregi("\.be", $ShoutPart)) OR (eregi("\.fm", $ShoutPart)) OR (eregi("\.ms", $ShoutPart)) OR (eregi("\.tc", $ShoutPart)) OR (eregi("\.co\.za", $ShoutPart)) OR (eregi("\.co\.nz", $ShoutPart)) OR (eregi("\.ph", $ShoutPart)) OR (eregi("\.dk", $ShoutPart)) OR (eregi("\.st", $ShoutPart)) OR (eregi("\.ac", $ShoutPart)) OR (eregi("\.gs", $ShoutPart)) OR (eregi("\.vg", $ShoutPart)) OR (eregi("\.sh", $ShoutPart)) OR (eregi("\.kz", $ShoutPart)) OR (eregi("\.as", $ShoutPart)) OR (eregi("\.lt", $ShoutPart)) OR (eregi("\.to", $ShoutPart)) OR (eregi("\.co\.il", $ShoutPart))) {
						$ShoutPart = "http://" . $ShoutPart;
						$ShoutNew[$i] = "&#91;<a target='_blank' href='$ShoutPart'>URL</a>&#93;";
					} elseif (strlen($ShoutPart) > 25) {
						$ShoutNew[$i] = wordwrap($ShoutPart, 25, " ", 1);
					} else { $ShoutNew[$i] = $ShoutPart; }
					$i++;
				}
				$shout_message = addslashes(implode(" ", $ShoutNew));
				// End
		
				if ($shout_name != "" && $shout_message != "") {
					$result = dbquery("SELECT MAX(shout_datestamp) AS last_shout FROM fusion_shoutbox WHERE shout_ip='".USER_IP."'");
					if (!iSUPERADMIN && dbrows($result) != 0) {
						$data = dbarray($result);
						if ((time() - $data['last_shout']) < $settings['flood_interval']) {
							$flood = true;
							$result = dbquery("INSERT INTO fusion_flood_control (flood_ip, flood_timestamp) VALUES ('".USER_IP."', '".time()."')");
							if (dbcount("(flood_ip)", "flood_control", "flood_ip='".USER_IP."'") > 4) {
								if (iMEMBER) {
									$result = dbquery("UPDATE fusion_users SET user_status='1' WHERE user_id='".$userdata['user_id']."'");
								}
							}
						}
					}
					if (!$flood) {
						if (isset($shout_id) && checkrights("S") && $aid == iAUTH) {
							$result = dbcount("(shout_id)", "shoutbox", "shout_id='$shout_id'");
							if ($result != 0) {
								if ($shout_user != "") {
									$result = dbcount("(user_id)", "users", "user_id='$shout_user' AND user_name='$shout_name'");
									if ($result != 0) {
										$result = dbquery("UPDATE fusion_shoutbox SET shout_message='$shout_message' WHERE shout_id='$shout_id'");
									}
								} else {
									$result = dbquery("UPDATE fusion_shoutbox SET shout_name='$shout_name',
										shout_message='$shout_message' WHERE shout_id='$shout_id'"
									);
								}
							}
						} else {
							$result = dbquery("INSERT INTO fusion_shoutbox (shout_name, shout_message, shout_datestamp, shout_ip)
								VALUES ('$shout_name', '$shout_message', '".time()."', '".USER_IP."')"
							);
//$result = dbquery("UPDATE ".DB_USERS." SET user_shout=user_shout+1 WHERE user_id='".$userdata['user_id']."'");						
						}
					}
				}
			}
		}
		$fsb_page .= "<div id='sb_form'>
<form name='shoutform' method='post' action='javascript:void(0)'>
<div align='center'>".$locale['fb_001']." <input type='text' name='commentlen' value='400' maxlength='3' size='3' style='margin-top:5px; margin-bottom:2px; text-align:center;' class='textbox' readonly></div>
<table align='center' cellpadding='0' cellspacing='0'>
<tr>
<td colspan='2'>\n";
		if (iGUEST) {
			$fsb_page .= $locale['global_151']."<br>
<input type='text' name='shout_name' value='' maxlength='30' style='width:140px;' class='textbox'><br>".$locale['global_152']."<br>\n";
		}
		$fsb_page .= "<center><textarea id='shout_message' name='shout_message' onKeyDown=\"textCounter(this.form.shout_message, this.form.commentlen, 400);\" onKeyUp=\"textCounter(this.form.shout_message, this.form.commentlen, 400);\" onFocus=\"textCounter(this.form.shout_message, this.form.commentlen, 400);\" rows='4' style='margin-bottom:-5px; width:140px;' class='textbox'></textarea></center>
</td>
</tr>
<tr>
<td align='center'>
<input type='button' name='post_shout'  onclick=\"sendData('shout', ''); return false\" value='shout'  style='margin-top:10px; margin-bottom:10px;' class='button'>
<div style='margin-top:-5px; margin-bottom:-1px;' align='center' class='tbl2'>
<a onClick=\"return overlay(this, 'shout_smiley', 'rightbottom')\" style='text-decoration:none; cursor: pointer; font-size:9px; font-weight:normal;'>".$locale['fb_003']."</a> |
<div id='shout_smiley' align='center' style='background-image:url(".INFUSIONS."shoutbox_panel/images/sb_bg.gif); position:absolute; display:none; border: 1px solid black; width: 200px; height: auto;' class='tbl1'>
".str_replace("<img src='".IMAGES, "<img src='".$images, displaysmileys("shout_message", "shout_smiley", "shoutform"))."
</div>
<a href=\"javascript:fuzetext('shout_message','[b]','[/b]');\" style='text-decoration:none; font-size:9px; font-weight:normal;'>".$locale['fb_004']."</a>
<br />
</div>
</td>
</tr>
</table>
</form>
</div>
<div id='sb_display'>\n";
		break;

	case "edit":
		$shout_id = isNum($_POST['shout_id']) ? $_POST['shout_id'] : 0;
		if (!empty($_POST['shout_id']) && checkrights("S"))  {
			$result = dbquery("SELECT * FROM fusion_shoutbox LEFT JOIN fusion_users
				ON shout_name=user_id WHERE shout_id='$shout_id'"
			);
			if (dbrows($result) != 0) {
				$data = dbarray($result);
				$fsb_page .= "<form name='shoutform' method='post' action='javascript:void(0)'>
<input type='hidden' name='shout_id' value='$shout_id'>
<div align='center'>".$locale['fb_001']." <input type='text' name='commentlen' value='400' maxlength='3' size='3' style='margin-top:5px; margin-bottom:2px; text-align:center;' class='textbox' readonly></div>
<table align='center' cellpadding='0' cellspacing='0'>
<tr>
<td colspan='2'>\n";
				if (!isset($data['user_name'])) {
					$fsb_page .= $locale['121']."<br>
<input type='text' name='shout_name' value='".$data['shout_name']."' maxlength='30' style='width:140px;' class='textbox'><br>".$locale['122']."<br>\n";
				} else {
					$fsb_page .= "<input type='hidden' name='user_id' value='".$data['user_id']."'>
<input type='hidden' name='shout_name' value='".$data['user_name']."'>".$data['user_name']."\n";
				}
				$fsb_page .= "<center><textarea id='shout_message' name='shout_message' onKeyDown=\"textCounter(this.form.shout_message, this.form.commentlen, 400);\" onKeyUp=\"textCounter(this.form.shout_message, this.form.commentlen, 400);\" onFocus=\"textCounter(this.form.shout_message, this.form.commentlen, 400);\" rows='4' style='margin-bottom:-5px; width:140px;' class='textbox'>".str_replace("<br>", "", $data['shout_message'])."</textarea></center>
</td>
</tr>
<tr>
<td align='center'>
<input type='button' name='post_shout'  onclick=\"sendData('shout', ''); return false\" value='shout' style='margin-top:10px; margin-bottom:10px;' class='button'>
<div style='margin-top:-5px; margin-bottom:-1px;' align='center' class='tbl2'>
<a onClick=\"return overlay(this, 'shout_smiley', 'rightbottom')\" style='text-decoration:none; cursor: pointer; font-size:9px; font-weight:normal;'>".$locale['fb_003']."</a> |
<div id='shout_smiley' align='center' style='background-image:url(".INFUSIONS."shoutbox_panel/images/sb_bg.gif); position:absolute; display:none; border: 1px solid black; width: 200px; height: auto;' class='tbl1'>
".str_replace("<img src='".IMAGES, "<img src='".$images, displaysmileys("shout_message", "shout_smiley", "shoutform"))."
</div>
<a href=\"javascript:fuzetext('shout_message','[b]','[/b]');\" style='text-decoration:none; font-size:9px; font-weight:normal;'>".$locale['fb_004']."</a> | <a href=\"javascript:fuzetext('shout_message','[i]','[/i]');\" style='text-decoration:none; font-size:9px; font-weight:normal;'>".$locale['fb_004']."</a> | 
<a onClick=\"return overlay(this, 'shout_palette', 'rightbottom')\" style='text-decoration:none; cursor: pointer; font-size:9px; font-weight:normal;'>".$locale['fb_005']."</a> |
<div id='shout_palette' align='center' style='background-image:url(".INFUSIONS."shoutbox_panel/images/sb_bg.gif); position:absolute; display:none; border: 1px solid black; width: 80px; height: auto;' class='tbl1'>
".colorPalette('v', $images, 10, 7)."
</div>
<span style='cursor:default; font-size:9px; font-weight:normal; text-decoration: none;' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_016']."] body=[".phpentities($locale['fb_017'])."] delay=[0] fade=[on]\">".$locale['fb_018']."</span><br />
</div>
</td>
</tr>
</table>
</form>\n";
			}
		}
		break;

	case "delete":
		//if (isNum($_POST['shout_id']) && checkrights("S") && $aid == iAUTH) {
			$aid = stripinput($_POST['aid']);
			$shout_id = isNum($_POST['shout_id']) ? $_POST['shout_id'] : 0;
			if (!empty($shout_id) && $shout_id != 1 && checkrights("S") && $aid == iAUTH) {
			$result = dbquery("DELETE FROM fusion_shoutbox WHERE shout_id='$shout_id'");
		}
		break;

	case "ban":
		$aid = stripinput($_POST['aid']);
		$user_id = isNum($_POST['uid']) ? $_POST['uid'] : 0;
		if (!empty($user_id) && $user_id != 1 && checkrights("S") && $aid == iAUTH) {
			$result = dbquery("UPDATE fusion_users SET user_status='1'
				WHERE user_id='$user_id' AND user_id!='".$userdata['user_id']."' AND user_level!='103'"
			);
		}
		break;

	case "unban":
		$aid = stripinput($_POST['aid']);
		$user_id = isNum($_POST['uid']) ? $_POST['uid'] : 0;
		if (!empty($user_id) && $user_id != 1 && checkrights("S") && $aid == iAUTH) {
			$result = dbquery("UPDATE fusion_users SET user_status='0' WHERE user_id='$user_id'");
		}
		break;
}

if ($sb_action != "edit") {
	$shout_counter = 0;
	$result = dbquery("SELECT * FROM fusion_shoutbox LEFT JOIN fusion_users
		ON shout_name=user_id ORDER BY shout_datestamp DESC LIMIT ".($min + $max)
	);
	$numrows = dbrows($result);
	if ($numrows != 0) {
		$i = 0;
		if (iMEMBER) { $fsb_page .= "<br>"; }
		while ($data = dbarray($result)) {

/*******************************************************************
* Begin show more feature.
********************************************************************/

			if ($shout_counter == $min) {
				$fsb_page .= "<center><img alt='' border='0' src='".$theme."images/bullet.gif'> <a href=\"javascript:void(0)\" onClick=\"document.getElementById('show_more').style.display = document.getElementById('show_more').style.display == 'none' ? 'block' : 'none';\">".$locale['fb_008']."</a> <img alt='' border='0' src='".$theme."images/bulletb.gif'> </center><div id='show_more' style='display: none;'><br>";
			}

/*******************************************************************
* End show more feature.
********************************************************************/

/*******************************************************************
* Modded for user ban display names, send private message and member homepage.
*******************************************************************/

			if (iMEMBER) {
				if ($data['user_id'] == $userdata['user_id']) {
					$fsb_page .= "<img alt='' src='".$theme."images/bullet.gif'> ";
				} elseif ($data['user_status'] != 1) {
					if (!isset($data['user_id']) || $data['user_id'] != $userdata['user_id']) {
						$fsb_page .= "<span class='shoutboxname'><a onClick=\"fuzetext('shout_message','[b]@".(isset($data['user_name']) ? $data['user_name'] : $data['shout_name']).":[/b] - ','');\" style='cursor:pointer;'><img src='".$infusions."shoutbox_panel/images/amp.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_006']."] body=[".phpentities($locale['fb_034'])."] delay=[0] fade=[on]\" alt='' border='0'></a></span> ";
					}
					if (isset($data['user_id']) && $data['user_id'] != $userdata['user_id']) {
						$fsb_page .= "<a href='".$basedir."messages.php?msg_send=".$data['user_id']."'><img src='".$infusions."shoutbox_panel/images/pm.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_007']."] body=[".phpentities($locale['fb_035'])."] delay=[0] fade=[on]\" alt='' border='0'></a> ";
					}
					if ($data['user_web']) {
						if (!strstr($data['user_web'], "http://")) { $urlprefix = "http://"; } else { $urlprefix = ""; }
						$fsb_page .= "<a href='".$urlprefix."".$data['user_web']."' target='_blank'><img alt='' src='".$infusions."shoutbox_panel/images/w3.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_013']."] body=[".phpentities($locale['fb_037'])."] delay=[0] fade=[on]\" border='0'></a> ";
					}
				} elseif ($data['user_status'] == 1) {
					$fsb_page .= "<img alt='' style='vertical-align:middle;' src='".$infusions."shoutbox_panel/images/banned.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_012']."] body=[".phpentities($locale['fb_038'])."] delay=[0] fade=[on]\">";
				}
			} else {
				if ($data['user_status'] == 1) {
					$fsb_page .= "<img alt='' style='vertical-align:middle;' src='".$infusions."shoutbox_panel/images/banned.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_012']."] body=[".phpentities($locale['fb_038'])."] delay=[0] fade=[on]\">";
				} else { $fsb_page .= "<img alt='' src='".$theme."images/bullet.gif'> "; }
			}

/*******************************************************************
* End ban display names.
*******************************************************************/

/*******************************************************************
* Modded for colored names.
*******************************************************************/

			$lastseen = time() - $data['user_lastvisit'];
			if ($lastseen < 60) {
				$lastseen = "<img src='".$infusions."shoutbox_panel/images/online.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_014']."] body=[<font color='red'><b>".phpentities($data['user_name']."</b></font>, ".$locale['fb_040'])."] delay=[0] fade=[on]\" alt='' style='vertical-align: middle;'>";
			} else {
				$lastseen = "<img src='".$infusions."shoutbox_panel/images/offline.png' title=\"header=[<img src='".$infusions."shoutbox_panel/images/info.gif' style='vertical-align: middle;'> ".$locale['fb_015']."] body=[<font color='red'><b>".phpentities($data['user_name']."</b></font>, ".$locale['fb_041'])."] delay=[0] fade=[on]\" alt='' style='vertical-align: middle;'>";
			}
			$shoutcount = dbcount("(shout_id)", "fusion_shoutbox", "shout_name='".$data['user_id']."'");
			if ($data['user_level'] == "103") { $userx = "<font color='#F75013'><b>".$data['user_name']."</b></font>"; }
			elseif ($data['user_level'] == "102") { $userx = "<font color='#008000'><b>".$data['user_name']."</b></font>"; }
			elseif ($data['user_level'] == "101") { $userx = "<font color='#3333CC'><b>".$data['user_name']."</b></font>"; }
			if ($data['user_status'] == 1) { $userx = "<font color='#A38C54'><b>".$data['user_name']."</b></font>"; }
			
			
			

/*******************************************************************
* End color mod.
*******************************************************************/

			if ($data['user_status'] == 1) {
				$fsb_page .= "<span style='cursor:default; text-decoration: none;' title=\"header=[".$data['user_name']." - <font color='red'>".$locale['fb_033']."</font>] body=[<center><img src='".$infusions."shoutbox_panel/images/banned.gif'></center></span><br><br>
<font color='$textcolor'><b>".$locale['fb_025']."</b>".$data['user_name']." - <b><font color='red'><i>".$locale['fb_026']."</i></b></font><br><br>
<font color='$textcolor'><b>".$locale['fb_027']."</b>".$locale['fb_028']."<br><br>
<b>".$locale['fb_029']."</b>".showdate("shortdate", $data['user_joined'])."<br><br>
<b>".$locale['fb_030']."</b>".showdate("shortdate", $data['user_lastvisit'])."<br><br>
<b>".$locale['fb_031']."</b>$shoutcount ".$locale['fb_032']."] delay=[0] fade=[on]\">
<a href='".$infusions."shoutbox_panel/banned.php?shout_user=".$data['shout_name']."' onClick=\"MyWindow=window.open('".$infusions."shoutbox_panel/banned.php?shout_user=".$data['shout_name']."','shoutbox','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=240,height=250'); return false;\" class='side'>$userx</a>
</span> - <font color='red'>".$locale['fb_022']."</font>";
			} else {
				if ($data['user_name']) {
					if ($data['user_avatar'] != "") { $avatar = "<img src='".$images."avatars/".$data['user_avatar']."'>"; }
					else { $avatar = "<img src='".$images."noimage.gif'>"; }
					$fsb_page .= "<span style='cursor:default; text-decoration: none;' title=\"header=[".$data['user_name']."] body=[</span><br>
<span class='$textcolor'><b>".$locale['fb_025']."</b>$userx<br><br>
<b>".$locale['fb_027']."</b>".getuserlevel($data['user_level'])."<br><br>
<b>".$locale['fb_029']."</b>".showdate("shortdate", $data['user_joined'])."<br><br>
<b>".$locale['fb_030']."</b>".showdate("shortdate", $data['user_lastvisit'])." <br><br>
<b>".$locale['fb_031']."</b>$shoutcount ".$locale['fb_032']."] delay=[0] fade=[on]\">
<a href='".$basedir."profile.php?lookup=".$data['user_id']."' class='side'>$userx</a>
</span>&nbsp;$lastseen";
				} else { $fsb_page .= $data['shout_name']."\n"; }
			}
			
			$fsb_page .= "<br>\n<span class='shoutboxdate'>".showdate("shortdate", $data['shout_datestamp'])."</span>";
			if (iADMIN && checkrights("S")) {
				$fsb_page .= "<br>\n[<a href=\"javascript:void(0)\" onClick=\"sendData('edit', '".$data['shout_id']."');\" class='side'>Edytuj</a> - <a href=\"javascript:void(0)\" onClick=\"sendData('delete', '".$data['shout_id']."');\" class='side'>Usu&#324;</a>] ";
				if ($data['user_status'] == "1") {
					$fsb_page .= "[<a href=\"javascript:void(0)\" onClick=\"sendData('unban', '".$data['user_id']."')\" class='side'>Odbanuj</a>]";
				} elseif ($data['user_status'] == "0" && $data['user_level'] != "103" && $data['user_id'] != $userdata['user_id']) {
$fsb_page .= "[<a href=\"javascript:void(0)\" onClick=\"sendData('ban', '".$data['user_id']."')\" class='side'>Banuj</a>]";
				}
				$fsb_page .= "<br><span style='font-size:8px;'>".$locale['fb_011'].$data['user_ip']."</span><br>";
			} else { $fsb_page .= "<br>\n"; }
			$fsb_page .= "<span class='shoutbox'>".str_replace("<img src='".IMAGES, "<img src='".$images, parseshoutubb(parseubb(parsesmileys($data['shout_message']))))."</span><br>\n";
			if ($i != $numrows) { $fsb_page .= "<br>\n"; }
			$shout_counter ++;
		}
	} else { $fsb_page .= "<div align='left'>".$locale['global_156']."</div>\n"; }
}
echo mb_convert_encoding($fsb_page, "UTF-8", $locale['charset']);
?>